unit Modedlg;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Spin, ExtCtrls, sysutils,  ComCtrls, printers,
  maths, uniteker, tableUtil, constTable,
  tableDef, tableGraphe, tableConst, oomisc;

type
  TmodeAcqDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Panel1: TPanel;
    Comports: TRadioGroup;
    TraceRG: TRadioGroup;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    XmaxSE: TSpinEdit;
    Label3: TLabel;
    YmaxSE: TSpinEdit;
    GroupBox2: TGroupBox;
    MotifCB: TCheckBox;
    Label1: TLabel;
    DimPointSE: TSpinEdit;
    LigneCB: TCheckBox;
    FechRG: TRadioGroup;
    GroupBox3: TGroupBox;
    ArretProxiCB: TCheckBox;
    TrcLogCB: TCheckBox;
    StyletCB: TCheckBox;
    GroupBox4: TGroupBox;
    PrintCB: TComboBox;
    DeltatLabel: TLabel;
    DeltatSE: TSpinEdit;
    EchelleSE: TSpinEdit;
    Label4: TLabel;
    WintabCB: TCheckBox;
    TempsRG: TRadioGroup;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure styletCBClick(Sender: TObject);
  private
    NumeroCom : array[0..MaxComHandles] of byte;
  public
    modifSerie,modifStylet : boolean;
  end;

var
  modeAcqDlg: TmodeAcqDlg;

implementation

uses tableMain;

{$R *.DFM}

procedure TmodeAcqDlg.OKBtnClick(Sender: TObject);
begin with TableMainForm.graphe do begin
     TraceMotif := MotifCB.checked;
     ModifStylet := avecStylet<>styletCB.checked;
     modifSerie := TrcLogCB.checked<>TableMainForm.AvecLogTrc;
     TableMainForm.AvecLogTrc := TrcLogCB.checked;
     modifSerie := modifSerie or (fechRG.itemIndex<>ord(vitesse));
     vitesse := Tvitesse(fechRG.itemIndex);
     TraceLigne := LigneCB.checked or not traceMotif;
     dimPoint := dimPointSE.value;
     echelleVecteur := echelleSE.value;     
     voies[voieX].maxi := XmaxSE.value / 1000;
     voies[voieY].maxi := YmaxSE.value / 1000;
     arretProxi := arretProxiCB.checked;
     modifSerie := modifSerie or
        (NumeroCom[ComPorts.itemIndex]<>tableMainForm.VoieSerie.ComNumber);
     tableMainForm.VoieSerie.ComNumber := NumeroCom[ComPorts.itemIndex];
     avecTrace := boolean(TraceRG.ItemIndex);
     indexImprimante := printCB.itemIndex;
     avecStylet := styletCB.checked;
     testWinTab := wintabCB.checked;
     TableMainForm.calculTemps := tTemps(tempsRG.ItemIndex);
     try
     deltatStylet := DeltatSE.value/1000;
     except
     end;
end end;

procedure TmodeAcqDlg.FormActivate(Sender: TObject);
var i : integer;
    indexCourant : integer;
begin with TableMainForm.graphe do begin
     TraceRG.ItemIndex := ord(avecTrace);
     fechRG.itemIndex := ord(vitesse);
     wintabCB.checked := testWinTab;
     TrcLogCB.checked := TableMainForm.AvecLogTrc;
     LigneCB.checked := traceLigne;
     MotifCB.checked := traceMotif;
     DimPointSE.value := dimPoint;
     EchelleSE.value := echelleVecteur;     
     XmaxSE.value := round(1000*voies[voieX].maxi);
     YmaxSE.value := round(1000*voies[voieY].maxi);
     arretProxiCB.checked := arretProxi;
     styletCB.checked := avecStylet;
     tempsRG.ItemIndex := ord(TableMainForm.calculTemps);
     ComPorts.items.clear;
     for i := 1 to MaxComHandles do
        if IsPortAvailable(i) then begin
           ComPorts.Items.Add('COM'+IntToStr(i));
           indexCourant := ComPorts.Items.count-1;
           NumeroCom[indexCourant] := i;
           if i=TableMainForm.voieSerie.ComNumber then ComPorts.itemIndex := indexCourant;
         end;
     if ComPorts.itemIndex<0 then ComPorts.itemIndex := 0;
     printCB.items := printer.printers;
     if indexImprimante>=printer.printers.Count then indexImprimante := -1;
     printCB.itemIndex := indexImprimante;
     DeltatSE.value := round(1000*deltatStylet);
     if indexImprimante<0
        then printCB.text := trSelectPrinter
        else printCB.text := printer.printers[indexImprimante]
end end;

procedure TmodeAcqDlg.CancelBtnClick(Sender: TObject);
begin
  modifSerie := false
end;

procedure TmodeAcqDlg.styletCBClick(Sender: TObject);
begin
  deltatSE.Visible := styletCB.Checked;
  deltatLabel.Visible := styletCB.Checked;
  FechRG.Visible := not styletCB.Checked;
end;

end.



