unit TableConst;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, SysUtils, iniFiles, dialogs, Grids,
  maths, tableUtil, ExtCtrls;

type
  TConstanteDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    GroupBox1: TGroupBox;
    EditComm: TEdit;
    NewPageCB: TRadioGroup;
    GroupBox2: TGroupBox;
    UniteL1: TLabel;
    NomConstEdit: TEdit;
    Label1: TLabel;
    UniteConstEdit: TEdit;
    Label2: TLabel;
    ValeurConstEdit: TEdit;
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
  public
      valeurConstante : double;
  end;

var
  ConstanteDlg: TConstanteDlg;

implementation

uses TableMain;

{$R *.DFM}

procedure TConstanteDlg.OKBtnClick(Sender: TObject);
begin
    try
       valeurConstante := StrToFloat(valeurConstEdit.text);
    except
       valeurConstante := sansSignif;
    end;
end;

procedure TConstanteDlg.FormCreate(Sender: TObject);
var Fichier : TMemIniFile;
begin
    valeurConstante := sansSignif;
    Fichier := TMemIniFile.create(TableMainForm.NomFichierConfig);
    with fichier,TableMainForm.graphe do begin
       nomConstEdit.text := ReadString('Constante','Nom','');
       editComm.text := ReadString('Constante','Comm','');
       uniteConstEdit.text := ReadString('Constante','Unit','');
    end;
    Fichier.free;
end;

procedure TConstanteDlg.FormDestroy(Sender: TObject);
var Fichier : TMemIniFile;
begin
   Fichier := TMemIniFile.create(TableMainForm.NomFichierConfig);
   with fichier,TableMainForm.graphe do begin
       WriteString('Constante','Nom',nomConstEdit.text);
       WriteString('Constante','Comm',editComm.text);
       WriteString('Constante','Unit',uniteConstEdit.text);
   end;
   Fichier.updateFile;
   Fichier.free;
end;

end.
