unit TableDDE;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, registry, clipbrd, oomisc,
  Maths, tableGraphe, uniteker,tableUtil, tableDef, ComCtrls;

type
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormCreate(Sender: TObject);
    procedure ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    procedure MajRegressi;
  public
      procedure Execute(Ordre : shortString);
      procedure EnvoieMouvement(versReg : boolean);
      procedure EnvoieNumerisation(versReg : boolean);
  end;

var
  FormDDE: TFormDDE;

implementation

uses tableMain, tableConst;

const crTab=#9;

{$R *.DFM}

procedure TFormDDE.Execute(Ordre : shortString);

Procedure lanceRegressi;
var hSemaphore : integer;
    CharVal: array[0..1024] of Char;
begin
   hSemaphore := CreateSemaphore(nil,0,1,'Regressi');
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   StrPCopy(CharVal, ClientDde.ServiceApplication);
   if WinExec(CharVal, SW_SHOWDEFAULT) >= 32 then sleep(2000);
end;

Procedure Lance;
var Buf: PChar;
begin
        Buf := StrAlloc(Succ(Length(Ordre)));
        if not ClientDDE.ExecuteMacro(StrPCopy(Buf,Ordre),false) then
             ShowMessage(Ordre+' non excut');
        StrDispose(Buf);
        ClientDDE.closeLink;
end;

begin
     LanceRegressi;
     ClientDDE.SetLink('Regressi','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
        then lance
        else begin
       // OpenLik false efface 
             ClientDDE.SetLink('Regressi','ServeurDDE');
             ClientItem.DDEItem := 'ServeurItem';
             delayTicks(18,true);
             if ClientDDE.OpenLink
                then lance
                else ShowMessage('Impossible de lancer Regressi');
        end;
end;

procedure TFormDDE.FormCreate(Sender: TObject);
begin
    MajRegressi
end;

procedure TFormDDE.EnvoieMouvement(versReg : boolean);
var i : indiceVecteur;
    v : indiceVoie;
    ligne : shortString;
    Donnees : TstringList;

procedure AjouteConst;
begin with ConstanteDlg do begin
     if (nomConstEdit.text='') or
        (valeurConstante=sansSignif) then exit;
     Donnees.Add('');
     Donnees.Add(nomConstEdit.text);
     Donnees.Add(uniteConstEdit.text);
     Donnees.Add(FloatToStrPoint(valeurConstante));
end end;

Procedure AjouteOptionsGr;
begin with TableMainForm.graphe do begin
     Donnees.Add(symbReg2+'1 NOMX');
     Donnees.Add('x');
     Donnees.Add(symbReg2+'1 NOMY');
     Donnees.Add('y');
     Donnees.add(SymbReg2+'1 ORTHO');
     Donnees.add('1');
end end;

var t0 : double;
begin with TableMainForm.graphe do begin { EnvoieDonnees }
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     Donnees.Add(Application.exeName);
     if versReg then begin
         if ConstanteDlg.NewPageCB.itemIndex=1
            then Donnees.Add('')
            else Donnees.Add('Acquisition par DIG-DEDOC');
         Donnees.Add(ConstanteDlg.editComm.text);
     end;    
     ligne := voies[voieT].nom;
     for v := succ(voieT) to voieY do with voies[v] do
           ligne := ligne + crTab + nom;
     Donnees.Add(ligne);
     ligne := voies[voieT].nomUnite;
     for v := succ(voieT) to voieY do with voies[v] do
            ligne := ligne + crTab + nomUnite;
     Donnees.Add(ligne);
     ligne := voies[voieT].signif;
     for v := succ(voieT) to voieY do with voies[v] do
           ligne := ligne + crTab + signif;
     Donnees.Add(ligne);
     t0 := voies[voieT].vecteur[0];
     for i := 0 to pred(Nbre) do begin
         ligne := FloatToStrPoint(voies[voieT].vecteur[i]-t0);
         for v := succ(voieT) to voieY do
             ligne := ligne + crTab + FloatToStrPoint(voies[v].vecteur[i]);
         Donnees.Add(ligne);
     end; { for i }
     if versReg then begin
        AjouteConst;
        if ConstanteDlg.NewPageCB.itemIndex=0 then AjouteOptionsGr;
     end;   
     ClipBoard.asText := Donnees.text;
     if versReg then if ConstanteDlg.NewPageCB.itemIndex=1
          then Execute('CLIP|ADD')
          else Execute('CLIP|LOAD');
     ConstanteDlg.NewPageCB.itemIndex := 1;
     Donnees.free;
     Screen.Cursor := crDefault;
end end; { EnvoieMouvement }

procedure TFormDDE.EnvoieNumerisation(versReg : boolean);
var i : indiceVecteur;
    v : indiceVoie;
    ligne : shortString;
    Donnees : TstringList;

procedure AjouteConst;
begin with ConstanteDlg do begin
     if (nomConstEdit.text='') or
        (valeurConstante=sansSignif) then exit;
     Donnees.Add('');
     Donnees.Add(nomConstEdit.text);
     Donnees.Add(uniteConstEdit.text);
     Donnees.Add(FloatToStrPoint(valeurConstante));
end end;

Procedure AjouteOptionsGr;
begin with TableMainForm.graphe do begin
     Donnees.Add(symbReg2+'1 NOMX');
     Donnees.Add('x');
     Donnees.Add(symbReg2+'1 NOMY');
     Donnees.Add('y');
     Donnees.add(SymbReg2+'1 ORTHO');
     Donnees.add('1');
end end;

var x,y : double;
begin with TableMainForm.graphe do begin { EnvoieDonnees }
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     Donnees.Add(Application.exeName);
     if versReg then begin
         if ConstanteDlg.NewPageCB.itemIndex=1
            then Donnees.Add('')
            else Donnees.Add('Acquisition par table  numriser');
         Donnees.Add(ConstanteDlg.editComm.text);
     end;    
     ligne := voies[voieT].nom;
     for v := succ(voieT) to voieY do with voies[v] do
           ligne := ligne + crTab + nom;
     Donnees.Add(ligne);
     ligne := voies[voieT].nomUnite;
     for v := succ(voieT) to voieY do with voies[v] do
            ligne := ligne + crTab + nomUnite;
     Donnees.Add(ligne);
     ligne := voies[voieT].signif;
     for v := succ(voieT) to voieY do with voies[v] do
           ligne := ligne + crTab + signif;
     Donnees.Add(ligne);
     for i := 0 to pred(Nbre) do begin
         ligne := FloatToStrPoint(i*deltatStylet);
         conversionStylet(voies[voieX].vecteur[i],voies[voieY].vecteur[i],x,y);
         ligne := ligne + crTab + FloatToStrPoint(x);
         ligne := ligne + crTab + FloatToStrPoint(y);
         Donnees.Add(ligne);
     end; { for i }
     if versReg then begin
        AjouteConst;
        if ConstanteDlg.NewPageCB.itemIndex=0 then AjouteOptionsGr;
     end;   
     ClipBoard.asText := Donnees.text;
     if versReg then if ConstanteDlg.NewPageCB.itemIndex=1
          then Execute('CLIP|ADD')
          else Execute('CLIP|LOAD');
     ConstanteDlg.NewPageCB.itemIndex := 1;
     Donnees.free;
     Screen.Cursor := crDefault;
end end; { EnvoieNumerisation }

procedure TFormDDE.ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
var Fonction,NomFichier : shortString;
    ArgStart,ArgEnd : integer;
begin
     if (Msg.Count = 1) then begin
       try
       ArgStart := Pos('(',Msg[0]);
       ArgEnd := Pos(')',Msg[0]);
       if (ArgStart >= ArgEnd)
          then nomFichier := ''
          else nomFichier := Copy(Msg[0], Succ(ArgStart), ArgEnd - Succ(ArgStart));
       ArgStart := Pos('(',Msg[0]);
       if ArgStart>0
          then Fonction := Copy(Msg[0], 1, Pred(ArgStart))
          else Fonction := Msg[0];
       if (CompareText('CONFIG|LOAD',Fonction) = 0) or
          (CompareText('FILE|LOAD',Fonction) = 0) then begin
          TableMainForm.setFocus;
          exit;
       end;
       if (CompareText('CONFIG|SAVE',Fonction) = 0) or
          (CompareText('FILE|SAVE',Fonction) = 0) then begin
          exit;
       end;
       if CompareText('FOCUS',Fonction) = 0 then begin
           TableMainForm.setFocus;
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           ConstanteDlg.newPageCB.itemIndex := 1;
           TableMainForm.setFocus;
           exit;
       end;
       MessageDlg('Fonction inconnue : ' + Msg[0], mtError, [mbOK], 0);
       except
            MessageDlg('Syntaxe Macro DDE : Fonction(Paramtre)', mtError, [mbOK], 0);
       end;
     end
     else MessageDlg('Un message  la fois SVP', mtError, [mbOk], 0);
end;

procedure TFormDDE.MajRegressi;
var Ini : TRegIniFile;
    i : byte;
    taille : int64;
    nomFichier : shortString;
begin
    Ini := TRegIniFile.create('Software');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','');
    Ini.Free;
    Ini := TRegIniFile.create('Software\Regressi');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path',ClientDDE.ServiceApplication);
    Ini.Free;
    if ClientDDE.ServiceApplication='' then begin
    { disquette A 1 B 2 disque dur C 3 D 4 CDROM/USB D 4 E 5}
        for i := 4 to 5 do begin
            taille := DiskSize(i);
            if (taille>5e6) and (taille<800e6) then begin { CDROM }
                nomFichier := char(ord('A')+i-1)+':\Regressi.exe';
                if fileExists(nomFichier) then
                   ClientDDE.ServiceApplication := NomFichier;
            end;
        end; {for i}
    end;
    if ClientDDE.ServiceApplication='' then
       ClientDDE.ServiceApplication := 'regressi.exe';
end;

end.
