unit TableDef;

interface

uses sysutils, oomisc, graphics,
     uniteker, maths, tableUtil, adport;

Const
    crLF = #10;
    crCR = #13;
    UnInch = 0.0254; { en mtre }

type
   EserieError = class(Exception);
   Ttemps = (tTable,tHorloge);
   Tconnection = (cNone,cApro,cWintab);
   Tvoie = class(tunite)
          ValeurCourante : double;
          signif : shortString;
          Mini,Maxi : double;
          vecteur : Tvecteur;
          constructor create;
          Function AffVoltmetre : strUnite;
   end;
   Tvitesse = (vMaxi,Vdic2,vdiv8,vdiv32);
   TtypeTimer = (tNone,tTrace,tAttente);
   Tstockage = array[0..4] of byte;
   packedBin = class
          private
             Fstockage : Tstockage;
             function getValeurX : integer;
             function getValeurY : integer;
             function getProximity : boolean;
             function getSynchroneStylet : boolean;
             function getSynchrone : boolean;
             function getButtonPress : byte;
             procedure SetStockage(Index: Integer; Value: byte);
          public
             property valeurX : integer read getvaleurX;
             property valeurY : integer read getvaleurY;
             property proximity : boolean read getProximity;
             property synchroneStylet : boolean read getSynchroneStylet;
             property synchrone : boolean read getSynchrone;
             property ButtonPress : byte read getButtonPress;
             property stockage[index : integer] : byte write setStockage;
    end;

var resolutionX,resolutionY : double;
    testWintab : boolean = true;

const
   setResolution : array[100..106] of double =
      (UnInch/100,UnInch/200,0.0001,UnInch/400,UnInch/500,0.00005,UnInch/1000);
   codeVitesse : array[Tvitesse] of byte = ($51,$52,$53,$54);
   FreqEch : array[Tvitesse] of integer = (128,64,16,4);
   MaxiStylet = 6000;

implementation

Constructor Tvoie.create;
begin
     inherited create;
     signif := '';
     Maxi := 5;
     Mini := 0;
     ValeurCourante := 0;
end;

Function Tvoie.AffVoltmetre : strUnite;
begin
      result := nom+'='+IntToStr(round(valeurCourante*1000))+' mm'
end;

function packedBin.getValeurX : integer;
begin
       result := (Fstockage[1] and $7F)+
                 (Fstockage[2] and $7F)*128
end;

function packedBin.getValeurY : integer;
begin
      result := (Fstockage[3] and $7F)+
                (Fstockage[4] and $7F)*128
end;

function packedBin.GetSynchrone;
var test1,test0 : boolean;
begin
    Test1 := (Fstockage[0] and $18)=$18;
        // $18=011000  : 11=signes positifs
    Test0 := (not(Fstockage[0]) and $27)=$27;
       // $27=100111  : trois derniers bits 000 pas de boutons et premier bit ID call 0
    result := test1 and test0
end;

procedure packedBin.SetStockage(Index: Integer; Value: byte);
begin
     if (index>=0) and (index<=4) then Fstockage[index] := value;
end;

function packedBin.getProximity : boolean;
begin
    result := (Fstockage[0] and $40)=0
end;

function packedBin.getSynchroneStylet : boolean;
begin
    result := (valeurX<maxiStylet) and (valeurY<maxiStylet)
end;

function packedBin.getButtonPress : byte;
begin
    result := Fstockage[0] and $07
end;

end.
