unit TableMain;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, WinHelpViewer,
  AdPort, AdExcept, oomisc, clipBrd, inifiles, hirestmr,
  tableUtil, uniteker, tableDef, maths, tableGraphe, About, registry,
  tableDde, tableConst, ComCtrls, ToolWin, ImgList, Grids,
  constTable, JH_WinTab_Const, JH_WinTab;

type
  TTableMainForm = class(TForm)
    VoieSerie: TApdComPort;
    PanelCourbe: TPanel;
    Oscillo: TPaintBox;
    StatusBar: TStatusBar;
    ToolBar1: TToolBar;
    RegSaveBtn: TToolButton;
    ExitBtn: TToolButton;
    HelpBtn: TToolButton;
    ResetBtn: TToolButton;
    ModeBtn: TToolButton;
    StopBtn: TToolButton;
    ImageList1: TImageList;
    EnregistreBtn: TToolButton;
    EditBidon: TEdit;
    Timer1: TTimer;
    ToolButton1: TToolButton;
    CopyBtn: TToolButton;
    PrintBtn: TToolButton;
    EtalonBtn: TToolButton;
    VitesseBtn: TToolButton;
    AccBtn: TToolButton;
    PanelStylet: TPanel;
    GroupBox1: TGroupBox;
    Grid: TStringGrid;
    GroupBox2: TGroupBox;
    GridData: TStringGrid;
    EtalonMenu: TPopupMenu;
    Point11: TMenuItem;
    Point21: TMenuItem;
    Point31: TMenuItem;
    Etalonne: TMenuItem;
    UndoBtn: TToolButton;
    EtalonGridBtn: TBitBtn;
    ProgressBar1: TProgressBar;
    WinTab: TJanHWinTab;
    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure FileExit(Sender: TObject);
    procedure HelpAbout(Sender: TObject);
    procedure ModeItemClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure TriggerAvail(CP: TObject; Count: Word);
    procedure StopBtnClick(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Timer1Timer(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure CopyBtnClick(Sender: TObject);
    procedure PrintBtnClick(Sender: TObject);
    procedure EtalonBtnClick(Sender: TObject);
    procedure VitesseBtnClick(Sender: TObject);
    procedure AccBtnClick(Sender: TObject);
    procedure GridExit(Sender: TObject);
    procedure PointClick(Sender: TObject);
    procedure EtalonneClick(Sender: TObject);
    procedure EtalonMenuPopup(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure GridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure WinTabPacket(Sender: TObject; PacketSerial, Handle: HWND;
      Packet: TTabletPacket);
    procedure WinTabProximity(Sender: TObject; CTXHandle: HWND;
      Enter: Boolean);
    private
      AcqEnCours : boolean;
      etatStylet : TetatStylet;
      deltatCourant : double;
      typeTimer : TtypeTimer;
      Connection : Tconnection;
      premiereFois : boolean;
      valeurLue : packedBin;
      indexMagnum : integer;
      instantDebut : int64;
      synchroAfaire : boolean;
      instantReception,oldInstantReception : int64;
      StyletEffectue : array[TetatStylet] of boolean;
      WTproximity : boolean;
    procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
    Procedure SetBoutons;
    procedure SetValeur(Acol,Arow : integer);
    procedure ecritTable(ordre : byte);
    Procedure testTable;
    procedure FormatGrid(col,row : integer;x : double);
    procedure FormatGridData(col,row : integer;x : double);
    public
      graphe : Tgraphe;
      nomFichierConfig : string;
      avecLogTrc : boolean;
      CalculTemps : Ttemps;
   protected
   end;

var
  TableMainForm: TTableMainForm;

implementation

uses modeDlg;

const
  modeTrail = $40;      //
  modeChangeTrail = $41; // A
  modeLocation = $42;    // B

{$R *.DFM}

procedure TTableMainForm.AppMessage(var Msg: TMsg; var Handled: Boolean);

function NonCouperCopier : boolean;
var EditCtrl : TcustomEdit;
begin
   NonCouperCopier := true;
   if ( (msg.Wparam=24) or (msg.Wparam=3) ) and
      (Screen.ActiveControl is TCustomEdit)
      then begin
          EditCtrl := Screen.ActiveControl as TCustomEdit;
          if EditCtrl.SelLength > 0 then begin
             case msg.Wparam of
                 24 : EditCtrl.CutToClipBoard;
                 3 :  EditCtrl.CopyToClipBoard;
             end;
             Handled := true;
             NonCouperCopier := false;
          end;
   end;
end;

const
         GrecMaj : array[1..26] of char =
  ('A','B','C',deltaMaj,'E',phiMaj,gammaMaj,'H','I',psiMaj,'K',lambdaMaj,
   'M','N',videMaj,piMaj,thetaMaj,'R',sigmaMaj,'T','U','V',omegaMaj,xiMaj,'Y','Z');

        GrecMin : array[1..26] of char =
  (alpha,beta,chi,delta,epsilon,phi,gamma,eta,'i',psi,'k',lambda,
   mu,nu,vide,piMin,theta,rho,sigma,tau,'u','v',omega,xi,'y',zeta);

begin with Msg do
     if Message=wm_char then begin
            if (Wparam>0) and (Wparam<=26) then
             if (GetKeyState(vk_control)<0) then
                 if (GetKeyState(vk_shift)<0) or
                    (GetKeyState(vk_capital)<0)
                    then Wparam := ord(GrecMaj[Wparam])
                    else if (Wparam<>22) and NonCouperCopier
                      { Edition Windows copier coller couper }
                         then Wparam := ord(GrecMin[Wparam]);
    end;
end;

procedure TTableMainForm.FormCreate(Sender: TObject);

procedure LitConfig;
var Fichier : TMemIniFile;
begin
     if not FileExists(nomFichierConfig) then exit;
     Fichier := TMemIniFile.create(NomFichierConfig);
     with Fichier,graphe do begin
       avecLogTrc := ReadBool('Com','Test',false);
       vitesse := Tvitesse(ReadInteger('Acquisition','Vitesse',1));
       traceLigne := ReadBool('Affichage','Ligne',true);
       traceMotif := ReadBool('Affichage','Motif',false);
       testWintab := ReadBool('Acquisition','Wintab',false);
       vitesseBtn.down := ReadBool('Affichage','Vitesse',false);
       AccBtn.down := ReadBool('Affichage','Acc',false);
       arretProxi := ReadBool('Acquisition','arretProxi',true);
       indexImprimante := readInteger('Affichage','arretProxi',-1);
       echelleVecteur := readInteger('Affichage','Echelle',10);       
       avecTrace := ReadBool('Acquisition','Trace',true);
       deltatStylet := ReadFloat('Acquisition','Deltat',0.1);
       dimPoint := readInteger('Affichage','DimPoint',dimPoint);
       voieSerie.ComNumber := readInteger('Com','Num',1);
       voies[voieX].maxi := readFloat('X','Maxi',0.305); // 12 pouces
       voies[voieY].maxi := readFloat('Y','Maxi',0.305);
     end;
     fichier.free;
end; //  litConfig


procedure InitStylet;
begin with grid do begin
     Cells[0,0] := trNom;
     Cells[0,1] := trUnite;
     Cells[1,0] := graphe.voies[voieX].nom;
     Cells[1,1] := graphe.voies[voieX].nomUnite;
     Cells[2,0] := graphe.voies[voieY].nom;
     Cells[2,1] := graphe.voies[voieY].nomUnite;
     Cells[0,2] := trPoint+'1';
     Cells[0,3] := trPoint+'2';
     Cells[0,4] := trPoint+'3';
     formatGrid(1,2,graphe.Xd[1]);
     formatGrid(1,3,graphe.Xd[2]);
     formatGrid(1,4,graphe.Xd[3]);
     formatGrid(2,2,graphe.Yd[1]);
     formatGrid(2,3,graphe.Yd[2]);
     formatGrid(2,4,graphe.Yd[3]);
end end;

begin
  Application.OnHint := ShowHint;
  Application.OnMessage := AppMessage;
  valeurLue := packedBin.create;
  graphe := Tgraphe.create;
  graphe.canvas := oscillo.canvas;
  oscillo.Canvas.Font.Name := 'Regressi';
  oscillo.Canvas.Font.Size := 12;
  PremiereFois := true;
  connection := cNone;
  AcqEnCours := false;
  etatStylet := esAttente;
  Application.UpdateFormatSettings := false;
  DecimalSeparator := '.';
  NomFichierConfig := MesDocsDir+changeFileExt(extractFileName(application.exeName),'');
  initStylet;
  LitConfig;
  VoieSerie.TriggerLength := 1;
// longueur des donnes de la table = 5
end;

procedure TTableMainForm.ShowHint(Sender: TObject);
begin
    Caption := Application.Hint
end;

procedure TTableMainForm.FileExit(Sender: TObject);
begin
   Close
end;

procedure TTableMainForm.HelpAbout(Sender: TObject);
begin
    AboutBox.ShowModal
end;

procedure TTableMainForm.ecritTable(ordre : byte);
begin
    if connection=cApro then VoieSerie.OutPut := char(ordre)
end;

procedure TTableMainForm.ModeItemClick(Sender: TObject);
begin
    if ModeAcqDlg.showModal=mrOK
       then if ModeAcqDlg.ModifSerie
            then testTable
            else begin
                 if ModeAcqDlg.ModifStylet then if graphe.avecStylet
                    then begin
                        EnregistreBtn.enabled := false;
                        EcritTable(modeLocation) // position du stylet lors d'un click
                    end
                    else EcritTable($40);// trail : suivi en continu
                 EtalonBtn.visible := graphe.avecStylet;
                 UndoBtn.visible := graphe.avecStylet and (graphe.Nbre>0);
                 PanelStylet.visible := graphe.avecStylet;                 
                 oscillo.refresh;
            end;
end;

procedure TTableMainForm.FormActivate(Sender: TObject);

Procedure ReadFormPlacement;
var ini : TmemInifile;
begin
  try
        Ini := TmemIniFile.create(nomFichierConfig);
        WindowState := TwindowState(Ini.ReadInteger('Window','State',ord(wsNormal)));
        Height := Ini.ReadInteger('Window','Height',height);
        Width := Ini.ReadInteger('Window','Width',width);
        Top := Ini.ReadInteger('Window','Top',top);
        Left := Ini.ReadInteger('Window','Left',left);
        Ini.free;
  except
  end;
end;

begin
     if premiereFois then begin
        ReadFormPlacement;
        testTable;
        premiereFois := false;
     end;
end;

Procedure TTableMainForm.TestTable;

Procedure TestVoieSerie;
begin
   StatusBar.panels[2].text := comName(VoieSerie.ComNumber)+trVerif;
   try
   connection := cApro; // on fait comme si ...
   if avecLogTrc
      then begin
          VoieSerie.tracing := tlOn;
          VoieSerie.logging := tlOn;
      end
      else begin
          VoieSerie.tracing := tlOff;
          VoieSerie.logging := tlOff;
      end;
   VoieSerie.Open := true;
   EcritTable($22); // command enabled carac="
   EcritTable($0); // reset
   DelayTicks(5,true); // temps du reset
   EcritTable($22); // command enabled  carac="
   EcritTable($13); // Xoff
   except
      on EalReadyOpen do begin
         StatusBar.panels[2].text := comName(VoieSerie.ComNumber)+trutilise;
         AfficheErreur(StatusBar.panels[2].text,4);
      end;
      on EBadId do begin
         StatusBar.panels[2].text := comName(VoieSerie.ComNumber)+trInexist;
      end;
      on E:EapdException do begin
         VoieSerie.open := false;
         StatusBar.panels[2].text := comName(VoieSerie.ComNumber)+' '+E.message;
      end;
      else begin
         VoieSerie.open := false;
      end;
      connection := cNone;
   end;
   if connection=cApro then begin
         EcritTable($3A);// Mode summagraphic carac=:
         DelayTicks(2,true); // temps du reset
         EcritTable($30);// ID call 0 carac=0
         EcritTable($69);// 20 lpm soit 50 mm carac=i
 // va de $64  $6A
         resolutionX := setResolution[$69];
         resolutionY := resolutionX;
         EcritTable(codeVitesse[graphe.vitesse]);// taux d'envoi
         deltatCourant := 1/freqEch[graphe.vitesse];
 // va de $51  $54 carac=Q  T         
         EcritTable($46);// mode absolu  carac=F
         if graphe.avecStylet
            then EcritTable(modeLocation) // position du stylet lors d'un click
            else EcritTable($40);// trail carac=@
         indexMagnum := 0;
         SynchroAfaire := false;
         VoieSerie.onTriggerAvail := TriggerAvail;
         typeTimer := tAttente;
         timer1.enabled := true;
         EcritTable($11);// Xon
    end;
    AcqEnCours := false;
    etatStylet := esAttente;
    graphe.Nbre := 0;
    oscillo.refresh;
    SetBoutons;
end; // testVoieSerie

Procedure VerifWinTab;
var axe : TaxisReal;
begin
   StatusBar.panels[2].text := trVerif;
   connection := cWintab;
   WinTab.Active := true;// on fait comme si ...
   if not winTab.active then begin
      StatusBar.panels[2].text := 'pas de table';
      connection := cNone;
      exit;
   end;
   deltatCourant := 1/winTab.context.lcPktRate;
   axe := WinTab.AxeX;
   if axe.axResolution=0
         then begin
              resolutionX := graphe.voies[voieX].maxi/winTab.context.lcInExtX;
         end
         else begin
              resolutionX := Axe.axResolution;
              graphe.voies[voieX].maxi := (Axe.axMax-Axe.axMin)*ResolutionX;
         end;
   axe := WinTab.AxeY;
   if axe.axResolution=0
      then begin
           resolutionY := graphe.voies[voieY].maxi/winTab.context.lcInExtY;
      end
      else begin
           resolutionY := Axe.axResolution;
           graphe.voies[voieY].maxi := (Axe.axMax-Axe.axMin)*ResolutionY;
      end;
   indexMagnum := 0;
   typeTimer := tAttente;
   timer1.enabled := true;
   StatusBar.panels[2].text := wintab.DeviceName+' '+wintab.WinTabId;
   AcqEnCours := false;
   etatStylet := esAttente;
   graphe.Nbre := 0;
   WinTab.enabled := true;// envoie des paquets
   oscillo.refresh;
   SetBoutons;
end; // verifWintab

begin
    if testWintab then verifWintab;
    if connection=cNone then testVoieSerie
end;

procedure TTableMainForm.EnregistreBtnClick(Sender: TObject);
begin
    AcqEnCours := true;
    etatStylet := esAcquisition;
    Graphe.Nbre := 0;
    EnregistreBtn.visible := false;
    stopBtn.visible := true;
    QueryPerformanceCounter(InstantDebut);
    InstantReception := InstantDebut;
    oldInstantReception := InstantDebut;
    oscillo.refresh;
end;

Procedure TTableMainForm.SetBoutons;
begin with graphe do begin
     EnregistreBtn.visible := not(AcqEnCours);
     StopBtn.visible := AcqEnCours;
     RegSaveBtn.enabled := Nbre>4;
     CopyBtn.enabled := Nbre>4;
     PrintBtn.enabled := Nbre>4;
     EtalonBtn.visible := avecStylet;
     UndoBtn.visible := avecStylet and (Nbre>0);
     editBidon.setFocus;
end end;

procedure TTableMainForm.OscilloPaint(Sender: TObject);
begin
     graphe.versEcran(oscillo.canvas,oscillo.width,oscillo.height);
     if graphe.avecStylet then begin
        EtalonGridBtn.Visible :=
           styletEffectue[esPoint1] and
           styletEffectue[esPoint2] and
           styletEffectue[esPoint3] and
           not(styletEffectue[esAttente]);
        if not EtalonGridBtn.Visible then begin
           oscillo.Canvas.font.color := clRed;
           oscillo.Canvas.Font.Size := 10;
           oscillo.Canvas.TextOut(oscillo.width div 2,oscillo.height div 2,trDefPoint3);
        end;
     end;
     editBidon.setFocus;
end;

procedure TTableMainForm.FormClose(Sender: TObject;
  var Action: TCloseAction);

Procedure EcritConfig;
var Fichier : TMemIniFile;
begin
   Fichier := TMemIniFile.create(NomFichierConfig);
   with fichier,graphe do begin
       WriteInteger('Acquisition','Vitesse',ord(vitesse));
       WriteBool('Com','Test',avecLogTrc);
       WriteBool('Affichage','Ligne',traceLigne);
       WriteBool('Affichage','Motif',traceMotif);
       WriteBool('Acquisition','Trace',avecTrace);
       writeBool('Acquisition','arretProxi',arretProxi);
       writeBool('Acquisition','Wintab',testWintab);
       writeInteger('Affichage','Echelle',echelleVecteur);      
       writeInteger('Affichage','arretProxi',indexImprimante);
       WriteInteger('Affichage','DimPoint',dimPoint);
       writeInteger('Com','Num',VoieSerie.ComNumber);
       WriteBool('Affichage','Vitesse',mondeVecteur[mondeVitesse].trace);
       WriteFloat('Acquisition','Deltat',deltatStylet);       
       WriteBool('Affichage','Acc',mondeVecteur[mondeAcc].trace);
       writeFloat('X','Maxi',voies[voieX].maxi);
       writeFloat('Y','Maxi',voies[voieY].maxi);
       WriteInteger('Window','State',ord(WindowState));
       WriteInteger('Window','Height',height);
       WriteInteger('Window','Width',width);
       WriteInteger('Window','Top',top);
       WriteInteger('Window','Left',left);
//       WriteString('Repertoire','Regressi',repertoireRegressi);
   end;
   Fichier.updateFile;
   Fichier.free
end; // ecritConfig

begin
     if StopBtn.visible then StopBtnClick(sender);
     if avecLogTrc then begin
        VoieSerie.tracing := tlDump;
        VoieSerie.logging := tlDump;
     end;
     EcritConfig;
end;

procedure TTableMainForm.RegSaveBtnClick(Sender: TObject);
begin
   if ConstanteDlg.showModal=mrOk then if graphe.avecStylet
      then FormDDE.EnvoieNumerisation(true)
      else FormDDE.EnvoieMouvement(true)
end;

procedure TTableMainForm.StopBtnClick(Sender: TObject);
begin
    oscillo.Refresh;
    AcqEnCours := false;
    etatStylet := esAttente;
    SetBoutons;
end;

procedure TTableMainForm.ResetBtnClick(Sender: TObject);
var i : integer;
begin
    TestTable;
    for i := 0 to pred(gridData.RowCount) do
        gridData.Cells[1,i] := '';
end;

procedure TTableMainForm.HelpBtnClick(Sender: TObject);
begin
   Application.HelpFile := ChangeFileExt(Application.ExeName,'.HLP');
   Application.HelpCommand(HELP_CONTENTS, 0)
end;

procedure TTableMainForm.TriggerAvail(CP: TObject; Count: Word);

procedure AvailMagnum;
begin
   if valeurLue.synchrone
      then if valeurLue.proximity
           then with graphe do begin
                voies[voieX].ValeurCourante := valeurLue.valeurX*resolutionX;
                voies[voieY].ValeurCourante := valeurLue.valeurY*resolutionY;
                if AcqEnCours
                   then case calculTemps of
                       tHorloge : begin
                         voies[voieT].ValeurCourante := GetElapsedSec(InstantDebut,InstantReception);
                         if (oldInstantReception<>instantReception) then begin
// sinon reu dans le mme paquet mais gnr par la table  des instants diffrents
                            ajoutePointCourant;
                            oldInstantReception := instantReception;
                          end;  
                       end;
                       tTable : begin
                         voies[voieT].ValeurCourante := nbre*deltatCourant;
                         if (nbre=0) or
                            (voies[voieX].ValeurCourante<>voies[voieX].vecteur[Nbre-1]) or
                            (voies[voieY].ValeurCourante<>voies[voieY].vecteur[Nbre-1])
                              then ajoutePointCourant;
// premier point, sinon liminer doublon                               
                       end;
                   end
                   else begin
                      traceReticule;
                      statusBar.panels[2].text :=
                         voies[voieX].AffVoltmetre+' '+
                         voies[voieY].AffVoltmetre;
                   end;
                timer1.Enabled := false;
            end
            else with graphe do begin
                 voies[voieX].ValeurCourante := -voies[voieX].maxi;
                 voies[voieY].ValeurCourante := -voies[voieY].maxi;
                 if AcqEnCours
                    then begin
                         if arretProxi then if nbre>4
                               then stopBtnClick(nil)
                               else nbre := 0;
                    end
                    else begin
                     TraceReticule;
                     TypeTimer := tTrace;
                     timer1.Enabled := avecTrace and not avecStylet;
                     statusBar.panels[2].text := trMobileDehors;
                 end;
           end
      else synchroAfaire := true;
end; // AvailMagnum

procedure AvailStylet;
var boutons,j : byte;
    strBouton : shortString;
    i : integer;
    x,y : double;
begin
   boutons := valeurLue.ButtonPress;
   if valeurLue.synchroneStylet
      then if valeurLue.proximity then with graphe do begin
              voies[voieX].ValeurCourante := valeurLue.valeurX*resolutionX;
              voies[voieY].ValeurCourante := valeurLue.valeurY*resolutionY;
              statusBar.panels[2].text :=
                       voies[voieX].AffVoltmetre+' '+
                       voies[voieY].AffVoltmetre;
              if boutons<>0
                 then begin
                      case etatStylet of
                           esAcquisition : begin
                              voies[voieT].ValeurCourante := nbre;
                              ajoutePointCourant;
                              if GridData.rowCount<Nbre then GridData.rowCount := nbre + 8;
                              UndoBtn.visible := avecStylet and (Nbre>0);                              
                              gridData.Cells[0,pred(nbre)] := intTostr(Nbre);
                              conversionStylet(voies[voieX].vecteur[pred(nbre)],voies[voieY].vecteur[pred(nbre)],x,y);
                              formatGridData(1,pred(nbre),x);
                              formatGridData(2,pred(nbre),y);
                           end;
                           esPoint1 : begin
                              Xt[1] := voies[voieX].valeurCourante;
                              Yt[1] := voies[voieY].valeurCourante;
                              etatStylet := esPoint2;
                              StatusBar.panels[2].text := format(trClicPointRef,[nomStylet[etatStylet]]);
                              styletEffectue[esPoint1] := true;
                              oscillo.Refresh;
                           end;
                           esPoint2 : begin
                              Xt[2] := voies[voieX].valeurCourante;
                              Yt[2] := voies[voieY].valeurCourante;
                              etatStylet := esPoint3;
                              StatusBar.panels[2].text := format(trClicPointRef,[nomStylet[etatStylet]]);
                              styletEffectue[esPoint2] := true;
                              oscillo.Refresh;
                           end;
                           esPoint3 : begin
                              Xt[3] := voies[voieX].valeurCourante;
                              Yt[3] := voies[voieY].valeurCourante;
                              StatusBar.panels[2].text := trRemplirGrid;
                              styletEffectue[esPoint3] := true;
                              etatStylet := esAttente;
                              oscillo.Refresh;
                           end;
                           esAttente : ;
                      end;
                      strBouton := '';
                      j := 1;
                      for i := 1 to 3 do begin
                          if (boutons and j)<>0 then strBouton := strBouton + intToStr(i)+' ';
                          j := 2*j;
                      end;
                      strBouton := strBouton + trPresse;
                      timer1.Enabled := false;
                      traceReticule;
                 end
                 else StrBouton := trRien;
              StatusBar.panels[0].text := strBouton;
            end
            else with graphe do begin
                 voies[voieX].ValeurCourante := -voies[voieX].maxi;
                 voies[voieY].ValeurCourante := -voies[voieY].maxi;
                 TraceReticule;
                 TypeTimer := tTrace;
                 timer1.Enabled := avecTrace and not avecStylet;
                 statusBar.panels[2].text := trMobileDehors;
           end
      else synchroAfaire := true;
end; // AvailStylet

var i : integer;
    NewInstantReception : int64;
begin
     QueryPerformanceCounter(NewInstantReception);
     for i := 1 to count do
         if VoieSerie.CharReady // inutile ?
             then if synchroAfaire then begin
                  valeurLue.stockage[0] := ord(voieSerie.getChar);
                  if valeurLue.synchrone then begin
                        inc(indexMagnum);
                        synchroAfaire := false;
                  end;
             end
             else begin
                  if indexMagnum=0 then InstantReception := NewInstantReception;
                  valeurLue.stockage[indexMagnum] := ord(voieSerie.getChar);
                  if indexMagnum<4
                     then inc(indexMagnum)
                     else begin
                          indexMagnum := 0;
                          if graphe.avecStylet then availStylet else availMagnum;
                     end
             end
             else exit;// ne devrait pas arriver mais arrive ?? 
end; // TriggerAvail

procedure TTableMainForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
     if key=' ' then if enregistreBtn.visible
          then enregistreBtnClick(sender)
               else if stopBtn.visible
          then stopBtnClick(sender)
end;

procedure TTableMainForm.Timer1Timer(Sender: TObject);
begin
    if typeTimer=tTrace then oscillo.Refresh;
    if typeTimer=tAttente then
       StatusBar.panels[2].text := comName(VoieSerie.ComNumber)+trPasReponse;
    Timer1.enabled := false;
    typeTimer := tNone;
end;

procedure TTableMainForm.ToolButton1Click(Sender: TObject);
begin
     if aboutBox=nil then
        Application.CreateForm(TAboutBox, AboutBox);
     AboutBox.ShowModal
end;

procedure TTableMainForm.CopyBtnClick(Sender: TObject);
begin
   if graphe.avecStylet
      then FormDDE.EnvoieNumerisation(false)
      else FormDDE.EnvoieMouvement(false)
end;

procedure TTableMainForm.PrintBtnClick(Sender: TObject);
begin
    graphe.versImprimante
end;

procedure TTableMainForm.EtalonBtnClick(Sender: TObject);
begin
     etalonBtn.CheckMenuDropDown;
end;

procedure TTableMainForm.VitesseBtnClick(Sender: TObject);
begin
    graphe.mondeVecteur[mondeVitesse].trace := VitesseBtn.down;
    oscillo.Refresh;
end;

procedure TTableMainForm.AccBtnClick(Sender: TObject);
begin
    graphe.mondeVecteur[mondeAcc].trace := AccBtn.down;
    oscillo.Refresh;
end;

procedure TTableMainForm.SetValeur(Acol,Arow : integer);
begin
     case Arow of
          0 : begin
          if Acol=1 then graphe.voies[voieX].nom := grid.Cells[Acol,Arow];
          if Acol=2 then graphe.voies[voieY].nom := grid.Cells[Acol,Arow];
     end;
          1 : begin
          if Acol=1 then graphe.voies[voieX].nomUnite := grid.Cells[Acol,Arow];
          if Acol=2 then graphe.voies[voieY].nomUnite := grid.Cells[Acol,Arow];
     end;
          2,3,4 : begin
     if Acol=1 then graphe.Xd[Arow-1] := StrToFloat(grid.Cells[Acol,Arow]);
     if Acol=2 then graphe.Yd[Arow-1] := StrToFloat(grid.Cells[Acol,Arow]);
     end;
     end;
end;

procedure TTableMainForm.GridExit(Sender: TObject);
var col,row : integer;
begin
    if styletEffectue[esPoint1] and
       styletEffectue[esPoint2] and
       styletEffectue[esPoint3] then begin
          for col := 1 to 2 do
              for row := 1 to 5 do
                  setValeur(col,row);
          graphe.CalculeConversionStylet;
          styletEffectue[esAttente] := true;
          StatusBar.panels[2].text := '';
          EnregistreBtn.enabled := true;
          EtalonGridBtn.Visible := false;
    end;      
end;

procedure TTableMainForm.PointClick(Sender: TObject);
begin
     EtatStylet := TetatStylet((sender as Tcomponent).tag);
     StatusBar.panels[2].text := format(trClicPointRef,[nomStylet[etatStylet]]);
end;

procedure TTableMainForm.EtalonneClick(Sender: TObject);
begin
    GridExit(sender)
end;

procedure TTableMainForm.EtalonMenuPopup(Sender: TObject);
begin
    point21.Enabled := styletEffectue[esPoint1];
    point31.Enabled := styletEffectue[esPoint1] and styletEffectue[esPoint2];
    etalonne.Enabled := styletEffectue[esPoint1] and
                        styletEffectue[esPoint2] and
                        styletEffectue[esPoint3];
end;

procedure TTableMainForm.FormatGrid(col,row : integer;x : double);
begin
    grid.Cells[col,row] := FloatToStrF(x,ffGeneral,4,2);
end;

procedure TTableMainForm.FormatGridData(col,row : integer;x : double);
begin
    gridData.Cells[col,row] := FloatToStrF(x,ffGeneral,4,2);
end;

procedure TTableMainForm.UndoBtnClick(Sender: TObject);
begin
     gridData.Cells[1,pred(graphe.nbre)] := '';
     gridData.Cells[2,pred(graphe.nbre)] := '';
     dec(graphe.nbre);
     UndoBtn.visible := graphe.Nbre>0;
     oscillo.Refresh;
end;

procedure TTableMainForm.GridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
     styletEffectue[esAttente] := false;
     EnregistreBtn.Enabled := false;
     EtalonGridBtn.Visible :=
           styletEffectue[esPoint1] and
           styletEffectue[esPoint2] and
           styletEffectue[esPoint3];
end;

procedure TTableMainForm.WinTabPacket(Sender: TObject; PacketSerial,
  Handle: HWND; Packet: TTabletPacket);
var instant : int64;  
begin with graphe do begin
           voies[voieX].ValeurCourante := Packet.pkPosition.X*resolutionX;
           voies[voieY].ValeurCourante := Packet.pkPosition.Y*resolutionY;
           if AcqEnCours
              then begin
                   QueryPerformanceCounter(Instant);
                   voies[voieT].ValeurCourante := GetElapsedSec(InstantDebut,Instant);
                   ajoutePointCourant;
              end
              else begin
                   traceReticule;
                   statusBar.panels[2].text :=
                       voies[voieX].AffVoltmetre+' '+
                       voies[voieY].AffVoltmetre;
              end;
           timer1.Enabled := false;
end end; // WinTabPacket


procedure TTableMainForm.WinTabProximity(Sender: TObject; CTXHandle: HWND;
  Enter: Boolean);
begin
   WTproximity := enter;
   statusBar.panels[2].text := stPosMobile(WTproximity);
   if not WTproximity then with graphe do begin
          voies[voieX].ValeurCourante := -voies[voieX].maxi;
          voies[voieY].ValeurCourante := -voies[voieY].maxi;
          if AcqEnCours
             then begin
                  if arretProxi then if nbre>4
                      then stopBtnClick(nil)
                      else nbre := 0;
             end
             else begin
                  TraceReticule;
                  TypeTimer := tTrace;
                  timer1.Enabled := avecTrace and not avecStylet;
                  statusBar.panels[2].text := trMobileDehors;
            end;
   end
end;

end.
